/**
 * PuppetServer is a mini library that makes use of the processing net package to
 * allow a fluid connection with unreal. The sole purpose of this connection is to
 * manage the derived computer vision data for manipulation of a unreal character.
 *
 * All in all this is just a wrapper to make working with the server and the
 * planned server tools much easier to code top level. Nothing groundbreaking
 * here
 *
 * Puppet Show is a Devin Hunt and Alex West project!
 * by devin!
 */
class PuppetServer implements ConsoleInteractor{

  public final String SEND_TOKEN = "send ";     //the token needed to preceed a string to be sent

  private int port;             //the port the server is created on  private Server server;        
  private Server server;        //the actual server

  /**
   * The constructor, 'this' should always be passed in as the parent from the root
   */
  public PuppetServer(PApplet parent, int newPort){
    this.port = newPort;
    this.server = new Server(parent, this.port);
  }

  /**
   * Sends off a string to all clients connected at this moment
   */
  public void sendString(String message){
    //println("Sending String: "+message);
    server.write(message);
  }

  /**
   * Method to pass events that occur in the top level PApplet down
   * to the server class. Nice to see someone connecting.
   */
  public void eventOccured(Server someServer, Client someClient){
    //event declaration
  }

  /**
   * Event from the console!
   */
  public void consoleEvent(String input){
    //if the string starts with "send " then we have something to send!
    if(input.length() >= SEND_TOKEN.length()){
      if(input.substring(0, SEND_TOKEN.length()).equals(SEND_TOKEN)){
        this.sendString(input.substring(SEND_TOKEN.length(), input.length()));
        println("send: "+input.substring(SEND_TOKEN.length(), input.length()));
      }
    }
  }

  /**
   * GETTERS AND SETTERS
   */
  public int getPort(){
    return this.port; 
  }
}
