import processing.opengl.*;
import processing.net.*;
import processing.video.*;
import blobDetection.*;



//Some Globals
/**
 * Globals for Network
 */

public PuppetServer server;    // the server we are going to be using
public int newTime, oldTime; //some Timing variables

/**
 *Globals for the UI
 */

public Console console;       // the console we are using. 
public PImage calibrationImage;
public PImage bckdCard;


/**
 *Globals for Blobtracker
 */

public PImage mirrorImage;

// BlobDetection
public PuppetBlobTracker faceTracker;
public PuppetBlobTracker mouthTracker;
public PuppetBlobTracker thirdTracker;

public Capture cam;	// cam is an PImage

int whichFilter; //this tells us how we should filter the current Image

boolean newFrame=false;
boolean setupDone = false;
boolean calibSetupDone = false;



///////
// THESE MUST APPEAR IN PUPPET SHOW
PFont arial24;
PFont arial12;
PFont harmony8;
///////

ConfigBox test;
ConfigBox test2;
ConfigBox test3;

void setup(){
  size(800, 600, OPENGL);

  // fonts
  arial24 = loadFont("Arial-Black-24.vlw");
  arial12 = loadFont("Arial-Black-12.vlw");
  harmony8 = loadFont("FFFHarmony-8.vlw");

  // capture and trackers
  this.cam = new Capture(this, 40*4, 30*4, 15);
  this.newFrame = false;
  this.calibrationImage = new PImage(80, 60);

  // timing
  this.newTime = millis();
  this.oldTime = millis();

  // server this bitch
  this.server = new PuppetServer(this, 4906);

  //start Interface Stuff
  bckdCard = loadImage("card.png");
  test = new ConfigBox(arial24, arial12, harmony8, new Point(20, 596), this.server, new PuppetBlobTracker(this.calibrationImage.width, this.calibrationImage.height), bckdCard);
  test2 = new ConfigBox(arial24, arial12, harmony8, new Point(220, 596), this.server, new PuppetBlobTracker(this.calibrationImage.width, this.calibrationImage.height), bckdCard);
  test3 = new ConfigBox(arial24, arial12, harmony8, new Point(420, 596), this.server, new PuppetBlobTracker(this.calibrationImage.width, this.calibrationImage.height),bckdCard);

  this.console = new Console(this.harmony8, new Point(10, 170), 4, 10, 300);
  this.console.addInteractor(this.server);
  this.console.addLine("PuppetShow Server.");
  this.console.addLine("Running on port "+this.server.getPort());
  this.console.addLine("Server Started!");
  
  //End Interface Stuff
}


void captureEvent(Capture cam) {
  cam.read();
  this.mirrorImage = getMirror();
  newFrame = true;


}


void draw() {
  // Timing
  this.oldTime = this.newTime;
  this.newTime = millis();
  float delta = (this.newTime - this.oldTime) / 1000.0;

  if(this.newFrame && this.mirrorImage != null){
    this.newFrame = false;

    // form our image to work on!
    this.calibrationImage = new PImage(80, 60);
    this.calibrationImage.copy(mirrorImage, 0, 0, mirrorImage.width, mirrorImage.height, 0, 0, calibrationImage.width, calibrationImage.height);
  }

  if(this.calibrationImage != null && this.mirrorImage != null){
    image(mirrorImage, 0, 0, width, height);
    pushMatrix();
    translate(20, 20);
    image(calibrationImage, 0, 0);
    popMatrix();

    // hey, lets also update all out potential trackers
    test.setFrame(calibrationImage);
    test2.setFrame(calibrationImage);
    test3.setFrame(calibrationImage);
  }

  // Start Interface Stuff
  test.tick(delta);
  test.draw();
  test2.tick(delta);
  test2.draw();
  test3.tick(delta);
  test3.draw();
  // End Interface Stuff
}


void mousePressed(){

  //Start Interface Stuff
  this.test.mousePressed(new Point(mouseX, mouseY)); 
  this.test2.mousePressed(new Point(mouseX, mouseY)); 
  this.test3.mousePressed(new Point(mouseX, mouseY)); 
  //End Interface Stuff
}



/**
 * Mainly we need to the active element the info, WHICH can be be the console
 */
void keyPressed(){
  //Interface Stuff
  this.test.keyPressed(key);
  this.test2.keyPressed(key);
  this.test3.keyPressed(key);
  //End Interface Stuff
}

/**
 * PEE FEST ON THE INTERNET
 */
void serverEvent(Server someServer, Client someClient) {
  //this.console.addLine("Client connected on " + someClient.ip());
  println("Client connected on " + someClient.ip());
}

/**
 * Returns a mirrored image from the current cam frame
 */
PImage getMirror(){
  PImage mirror = (PImage) cam;

  color tempColor;
  for(int y = 0; y < mirror.height; y++){
    for(int x = 0; x < mirror.width / 2; x++){
      tempColor = mirror.pixels[y * mirror.width + x];
      mirror.pixels[y * mirror.width + x] = mirror.pixels[y * mirror.width + (mirror.width - x - 1)];
      mirror.pixels[y * mirror.width + (mirror.width - x - 1)] = tempColor;
    }
  }
  return mirror;
}


